质数与数差类题目:ZR2639三色堇
质数与数差类题目:ZR2639三色堇 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132325425 Trick 1 题目要求维护差的平方和。但发现差得数量很少。 对于维护和差有关的东西(比如此题中的 ∑(ai−ai−1)2\sum(a_i-a_{i-1})^2∑(ai−ai−1)2 ),如果差的数量很少,可以直接维护差的数量 fif_ifi ,最后可以计算为 i2×fii^2\times f_ii2×fi Trick 2 考虑数之间的差怎么转...
2023正睿金华暑假集训
本文搬运自本人初中博客园博客,若图片加载不出来,可到原文查看:https://www.cnblogs.com/zhangtingxi/p/17633348.html 说句题外话,这个博客不更是因为我转cnblogs了。 2023正睿金华暑假集训 7月15日,我跟随大队来到了金华 第一次参加暑假出省线下集训,之前在高中部集训过, 但都是校内的集训,没怎么出去过。唯一一次好像还是去六中集训,但最多也就是几个学校之间的小打小闹。 7月份是在C班集训,课没怎么听,主要是做C班的题目。那段时间,再加上7月初在高中的时候,补了一轮算法,省选基本算法大致都写了次模板了。 过来才知道,原来仅仅是C...
一道网络流题目和其相关套路:ZR2627紫罗兰
一道网络流题目和其相关套路:ZR2627紫罗兰 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132296366 http://zhengruioi.com/problem/2627 Trick1:二分套网络流 首先可以对原图建模 中间拆点是为了两对棋子走到同一个格子上 然后我们发现每条边除了容量还有一个边权, 而我们的目标是求出 每一个流量下的最小边权 对于网络流中出现边权最值问题,可以进行二分。二分过程时枚举最值,然后 保留可行边 ,来跑网络流 T...
遍历bitset中的1:_Find_first和_Find_next
遍历bitset中的1:_Find_first和_Find_next 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132282353 1234bitset<N> a;for(int v=a._Find_first();v!=a.size();v=a._Find_next(v)){ pre[v]=u,vis[v]=1,q.push(v);} 注意返回的 vvv 是 位数
c++accumulate(),partial_sum(),fill()函数
c++accumulate(),partial_sum(),fill()函数 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132264428 accumulate() 求和,传入 begin指针、end指针,首项 12int a[5]={1, 2, 3, 4, 5}, b[5], c[5]; printf("%d\n", accumulate(a, a+5, 100)); 100+1+2+3+4+5=115 pa...
线段树记录系数维护动态信息:ZR2612
线段树记录系数维护动态信息:ZR2612 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132255084 http://zhengruioi.com/problem/2612 ai+bj≥0a_i+b_j\ge 0ai+bj≥0 => ai≥−bja_i\ge -b_jai≥−bj 因此考虑把 bbb 去负, ai≥bja_i\ge b_jai≥bj 也就是一个区间 aaa 最小值大于 bbb 最大值 套路1 (大小关系转不同) 对于此...
对平移类DP用数据结构优化:ZR2617
对平移类dp用数据结构优化:ZR2617 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132240791 http://zhengruioi.com/problem/2617 对于此类dp式子: dpi,j=∑dpk,j−w(k,i)dp_{i,j}=\sum dp_{k,j-w(k,i)} dpi,j=∑dpk,j−w(k,i) 暴力计算为 O(n3)O(n^3)O(n3) ,但如果 w(j,i)w(j,i)w(j,i) 在 w(j,i−1)w(j,...
颜色类问题与分治:P7215
颜色类问题与分治:P7215 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132221132 https://www.luogu.com.cn/problem/P7215 化为点分治后,把原问题变成钦定一个点必选的问题 转化这一步是点分治维护颜色类题目的一个性质,如果某种颜色外面有,就会在外面被考虑,不需要在此层 对朴素分治也有启发,对于在大区间统计了的答案,就不需要在小区间统计了 考虑在钦定一个点必选时,怎么做,首先把它定义为根。 把每种颜色丢入一个...
点分治过程中维护李超线段树:CF1303G
点分治过程中维护李超线段树:CF1303G 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132219909 https://www.luogu.com.cn/problem/CF1303G 看到这题,首先很容易想到树形dp,但发现要维护两个值,一个为末项,一个为和,很好分析出这个东西有凸性。 这个时候有两种做法,维护凸包或李超线段树。 之所以用李超线段树,是可以想象出维护末项(k)和和 (b)之后最终的答案其实之和队对面的深度(x)有关,而这个大胆猜测可以...
李超线段树
李超线段树 本文搬运自本人高中时期CSDN博客,若图片加载不出来,可到原文查看:https://blog.csdn.net/zhangtingxiqwq/article/details/132217504 插入过程中,先询问中点,让 uuu 在上,它必然覆盖其中一个区间。 然后看看左右端点哪里 vvv 比 uuu 大,就在对应区间递归下去












